package org.zheng.demo.module;

import java.io.IOException;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonDeserializer;

public class CustLocalDateDeserializer extends JsonDeserializer<LocalDate> {

	private static final DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MMMM-dd");

	@Override
	public LocalDate deserialize(JsonParser p, DeserializationContext ctxt) throws IOException {
		String date = p.getText();
		if (date.startsWith("Past")) {
			date = date.substring("Past: ".length());
		}
		return LocalDate.parse(date, formatter);
	}

}
