package org.zheng.demo.module;

import java.io.IOException;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;

public class CustLocalDateSerializer extends JsonSerializer<LocalDate> {

	private static final DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MMMM-dd");

	@Override
	public void serialize(LocalDate date, JsonGenerator gen, SerializerProvider provider) throws IOException {

		if (date.isBefore(LocalDate.now())) {
			// Apply special formatting for past dates
			String formattedDate = "Past: " + date.format(formatter);
			gen.writeString(formattedDate);
		} else {
			// Default formatting
			String formattedDate = date.format(formatter);
			gen.writeString(formattedDate);
		}
	}

}
