package org.zheng.demo;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertTrue;

import java.time.LocalDate;

import org.junit.jupiter.api.Test;
import org.zheng.demo.data.Person;
import org.zheng.demo.module.CustLocalDateModule;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;

public class TestCustLocalDateModule {
	@Test
	void test_custLocalDate() throws JsonProcessingException {

		ObjectMapper ob = new ObjectMapper();
		Person per = new Person("Zheng");

		ob.registerModule(new CustLocalDateModule());

		per.setLocalDateJsr310(LocalDate.of(2020, 01, 01));
		per.setLocalDateObj(LocalDate.of(1970, 01, 01));

		String jsonString = ob.writeValueAsString(per);
		System.out.println(ob.writerWithDefaultPrettyPrinter().writeValueAsString(per));

		Person readPer = ob.readValue(jsonString, Person.class);
		assertTrue(per.equals(readPer));
		assertEquals("Zheng", readPer.getName());
		assertEquals(0, readPer.getAge());
		assertEquals(LocalDate.of(1970, 1, 1), readPer.getLocalDateObj());
		assertEquals(LocalDate.of(2020, 1, 1), readPer.getLocalDateJsr310());

	}
}
