package org.zheng.demo;

import static org.junit.jupiter.api.Assertions.assertThrows;
import static org.junit.jupiter.api.Assertions.assertTrue;

import java.time.LocalDate;

import org.junit.jupiter.api.Test;
import org.zheng.demo.data.Person;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.exc.InvalidDefinitionException;

class TestDefaultObjectMapper {

	ObjectMapper ob = new ObjectMapper();
	Person per = new Person("Zheng");

	@Test
	void test_default_ok_without_loaldate() {
		try {
			String jsonStr = ob.writeValueAsString(per);
			System.out.println(jsonStr);
		} catch (JsonProcessingException e) {
			e.printStackTrace();
		}
	}

	@Test
	void test_default_throw_exception_with_localDate() {
		per.setLocalDateObj(LocalDate.of(1970, 01, 01));

		InvalidDefinitionException expectedException = assertThrows(InvalidDefinitionException.class,
				() -> ob.writeValueAsString(per));
		assertTrue(expectedException.getMessage().contains(
				"Java 8 date/time type `java.time.LocalDate` not supported by default: add Module \"com.fasterxml.jackson.datatype:jackson-datatype-jsr310\" to enable handling"));

	}

}
